/*
 * Minidxr2 - Linux DVD player. Mostly (C) Jack Whitham, 2001
 *
 */
#ifndef BUFFER_H
#define BUFFER_H

#include "player.h"


/* buf_playback_controller command codes */
#define PBC_SEEK			1
#define PBC_STOP			2
#define PBC_START			3
#define PBC_GET_POS			4
#define PBC_QUIT			5
#define PBC_GET_LENGTH		6
#define PBC_SET_TITLE		7
#define PBC_SET_ANGLE		8

/* file types */
#define TYPE_UNKNOWN		0
#define TYPE_MPEG			1
#define TYPE_VOB			2

#define TITLE_FILENAME			"/video_ts/vts_%02d_%d.vob"


char * buf_open_files ( player_info_t * player_info , 
		char ** file_list , int num_files ) ;
char * buf_close_files ( player_info_t * player_info ) ;
int buf_get_lbas ( player_info_t * player_info , char * error , int max_chars ) ;
int buf_files_on_dvd ( player_info_t * player_info ) ;
char * buf_playback_controller ( player_info_t * player_info , 
			int command , int * parameter ) ;

void * buf_reader ( void * arg ) ;
void * buf_writer ( void * arg ) ;
void buf_setup ( player_info_t * player_info ) ;
void buf_clear_buffers ( player_info_t * player_info ) ;

int buf_add_to_buffer ( buffer_type * buf , buffer_item * item ) ;
buffer_item * buf_remove_from_buffer ( buffer_type * buf ) ;
int buf_is_space_in_buffer ( buffer_type * buf ) ;
buffer_type * buf_make_buffer ( int size ) ;
int buf_is_on_dvd ( player_info_t * p , char * filename ) ;
int buf_get_type_from_name ( char * name ) ;

#endif 

