#include <gnome.h>
#include <stdlib.h>
#include <string.h>

#include "callbacks.h"
#include "gui_iface.h"
#include "support.h"

#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <pwd.h>


        GtkWidget *property1;
        GtkWidget *dialog1;
        GtkWidget *fileselection1;
        GtkWidget *about2;
        GtkWidget *on_the_fly;
        GtkWidget *play_control;
        GtkWidget *popup_menu;


        pthread_t read_thread;
        pthread_t write_thread;
        pthread_attr_t thread_attrib;

        player_info_t * player_info;
        player_info_t * tmp_player_info; 	//only used for the properties dialog

        output_plugin_fn	output ;

	char    temp_string [ BUFFER_LENGTH ] ;
        char    *err;
        char    *err2;
 	char    errbuf [ BUFFER_LENGTH ] ;

	int     cur_opt ;
	output_plugin_fn        output ;

        int c;			// counter var
        gchar *temp_device;

        // timebar variables
        guint timebar_timeout_id ;
        gpointer temp;



// ****************************************************************************************
// commands to play dvd: play, stop, forward, ...
// ****************************************************************************************
void
on_play_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
        // timebar stuff
        GtkWidget *p_scale;
        GtkAdjustment *p_adj;


        if ( ! ( player_info -> h_state == DVD_PLAYING ) ) {

                /* load the dvd (load_dvd) */
                err = device_mount ( player_info ) ;	/* ignore mount errors */
                if ( ! dvd_open_title ( player_info , -1 , errbuf , BUFFER_LENGTH_1 ) )
                {
                        err = errbuf ;
                } else {
                        err = NULL ;
                }
                if ( err )
                        fprintf(stderr, "%s\n", err);

                // play command
                err = dvd_play ( player_info ) ;
                if ( err )
                        fprintf(stderr, "%s\n", err);

                err = dvd_print_audio_info ( player_info , temp_string , BUFFER_LENGTH_1);
                if ( err )
                        fprintf( stderr , "%s\n", err );


                on_the_fly = create_on_the_fly();
                gtk_widget_show(on_the_fly);

                play_control = create_play_control();
                gtk_widget_show(play_control);


                // sets up differnt things for the timebar
                p_scale = GTK_WIDGET( gtk_object_get_data( GTK_OBJECT(
                                          play_control ), "timebar" ) );
                p_adj = gtk_range_get_adjustment ( GTK_RANGE( p_scale ) );

                // gets the total time of the movie and sets up the upper range of the timebar...
                err = dvd_print_total_time ( player_info , temp_string , BUFFER_LENGTH_1 ) ;
                if ( err )
                        fprintf ( stderr , "%s\n" , err ) ;
                else
                        p_adj->upper = ( atoi ( ( char * ) &temp_string [ 0 ] ) * 60 )    +    ( atoi ( ( char * ) &temp_string [ 2 ] ) );

                // update the timebar every five second (because it only shows minutes this should be enough)
                timebar_timeout_id = gtk_timeout_add ( 500, update_timebar , temp ) ;


        }
        else {
                fprintf ( stderr , "Still playing...\n" ) ;
        }
}


void
on_stop_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
        gtk_widget_hide(on_the_fly);

        gtk_widget_hide(play_control);

        err = dvd_stop ( player_info ) ;
        if ( err )
                fprintf(stderr, "%s\n", err);

        gtk_timeout_remove ( timebar_timeout_id ) ;

        err = dvd_unload ( player_info ) ;
        if ( err )
                fprintf ( stderr , "%s\n" , err ) ;

        err = device_unmount ( player_info ) ;
        if ( err )
                fprintf ( stderr , "%s\n" , err ) ;
        else {
                gtk_widget_hide(on_the_fly);

                gtk_widget_hide(play_control);

                gtk_timeout_remove ( timebar_timeout_id ) ;
        }
}


void
on_pause_button_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
        err = dvd_pause ( player_info );
        if ( err ) {
                fprintf ( stderr , "%s" , err ) ;
        }
}



void
on_overlay_on_off_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
#ifdef HAVE_X_OVERLAY_SUPPORT
        if (GTK_TOGGLE_BUTTON (togglebutton)->active)
        {
                err = dvd_set_view_mode ( player_info , OUTPUT_VIEW_WINDOW ) ;

        } else {
                err = dvd_set_view_mode ( player_info , OUTPUT_VIEW_OFF ) ;
        }
#endif
}



void
on_eject_dvd_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
        err = dvd_unload ( player_info ) ;
        if ( err == NULL )
        {
                err2 = device_unmount ( player_info ) ;
                err = device_eject ( player_info ) ;
                if ( err != NULL )
                {
                        fprintf ( stderr , "%s\n" , err ) ;
                }
                gtk_widget_hide(on_the_fly);

                gtk_widget_hide(play_control);

                gtk_timeout_remove ( timebar_timeout_id ) ;
        }
}


void
on_reload_dvd_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
        err = device_mount ( player_info ) ;	/* ignore mount errors */
        if ( ! dvd_open_title ( player_info , -1 , errbuf , BUFFER_LENGTH_1 ) )
        {
                err = errbuf ;
        } else {
        err = NULL ;
        }
}

// ****************************************************************************************
//
// functions for setting properties
//
// ****************************************************************************************
void
on_settings_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  fprintf ( stderr , "Not yet implemented. Sorry...\n" ) ;
  fflush ( stderr ) ;
//  property1 = create_property1 ();
//  gtk_widget_show (property1);
}


void
on_prop_apply_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
//  dxr2_info.tv_format.arg = tmp_dxr2_info.tv_format.arg;
//  dxr2_info.video_freq.arg1 = tmp_dxr2_info.video_freq.arg1;
//  dxr2_info.scaling_mode.arg = tmp_dxr2_info.scaling_mode.arg;
//  dxr2_info.audio_stream.arg2 = tmp_dxr2_info.audio_stream.arg2;
//  dxr2_info.audio_stream.arg1 = tmp_dxr2_info.audio_stream.arg1;
//  dxr2_info.subpicture_stream_id.arg2 = tmp_dxr2_info.subpicture_stream_id.arg2;
//  dxr2_info.subpicture.arg = tmp_dxr2_info.subpicture.arg;
//  strcpy(player_info.dvd_device, tmp_player_info.dvd_device);
//  strcpy(player_info.dvd_mountpoint, tmp_player_info.dvd_mountpoint);
//
//  write_dxr2gui_config(&player_info, &dxr2_info);
}



void
on_prop_ok_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  on_prop_apply_clicked(button, user_data);

  gtk_widget_destroy(property1);

}


void
on_property1_show                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
  switch(player_info->default_tv_format) {
  case OUTPUT_FORMAT_NTSC: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_0")), TRUE);
    break; }
  case OUTPUT_FORMAT_NTSC_60: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_1")), TRUE);
    break; }
  case OUTPUT_FORMAT_PAL_M: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_2")), TRUE);
    break;}
  case OUTPUT_FORMAT_PAL_M_60: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_3")), TRUE);
    break;}
  case OUTPUT_FORMAT_PAL_BDGHI: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_4")), TRUE);
    break;}
  case OUTPUT_FORMAT_PAL_N: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_5")), TRUE);
    break;}
  case OUTPUT_FORMAT_PAL_Nc: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_6")), TRUE);
    break;}
  case OUTPUT_FORMAT_PAL_60: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_7")), TRUE);
    break;}
  }



  switch(player_info->default_video_freq) {
  case OUTPUT_SRC_VIDEO_FREQ_30: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_freq_0")), TRUE);
    break; }
  case OUTPUT_SRC_VIDEO_FREQ_25: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_freq_1")), TRUE);
    break; }
  }


// ******************************************************************************
// mount point of the dvd-device
// ******************************************************************************
  if (!strcmp(player_info->dvd_mountpoint, "/mnt/dvd"))
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"mount_mnt_dvd")), TRUE);

  else if (!strcmp(player_info->dvd_mountpoint, "/mnt/cdrom"))
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"mount_mnt_cdrom")), TRUE);

  else if (!strcmp(player_info->dvd_mountpoint, "/dvd"))
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"mount_dvd")), TRUE);

  else
    gtk_entry_set_text(GTK_ENTRY(lookup_widget(property1,"entry2")), player_info->dvd_mountpoint);

// ******************************************************************************
// devicepath of the dvd-device
// ******************************************************************************
  if (!strcmp(player_info->dvd_device, "/dev/dvd"))
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"dev_dev_dvd")), TRUE);

  else if (!strcmp(player_info->dvd_device, "/dev/cdrom"))
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"dev_dev_cdrom")), TRUE);

  else
    gtk_entry_set_text(GTK_ENTRY(lookup_widget(property1,"entry3")), player_info->dvd_device);


// ******************************************************************************
// tv-format
// ******************************************************************************
  switch(player_info->default_tv_format) {
  case OUTPUT_ASPECTRATIOMODE_LETTERBOX: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_format_0")), TRUE);
    break; }
  case OUTPUT_ASPECTRATIOMODE_NORMAL: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_format_1")), TRUE);
    break; }
  case OUTPUT_ASPECTRATIOMODE_PAN_SCAN: {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"tv_format_2")), TRUE);
    break; }
  }


//// ******************************************************************************
//// language selection
//// ******************************************************************************
//  switch(player_info->vurrent_) {
//  case 0: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"lan_0")), TRUE);
//    break; }
//  case 1: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"lan_1")), TRUE);
//    break; }
//  case 2: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"lan_2")), TRUE);
//    break; }
//  case 3: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"lan_3")), TRUE);
//    break; }
//  case 4: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"lan_4")), TRUE);
//    break; }
//  case 5: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"lan_5")), TRUE);
//    break; }
//  case 6: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"lan_6")), TRUE);
//    break; }
//  case 7: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"lan_7")), TRUE);
//    break; }
//  }
//
//
//  if(!dxr2_info.subpicture.arg==DXR2_SUBPICTURE_OFF)
//  {
//    switch(dxr2_info.subpicture_stream_id.arg2)
//    {
//    case 0: {
//      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"sub_0")), TRUE);
//      break; }
//    case 1: {
//      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"sub_1")), TRUE);
//      break; }
//    case 2: {
//      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"sub_2")), TRUE);
//      break; }
//    case 3: {
//      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"sub_3")), TRUE);
//      break; }
//    case 4: {
//      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"sub_4")), TRUE);
//      break; }
//    }
//  }
//  else
//  {
//      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"sub_off")), TRUE);
//  }
//
//
//
//  switch(dxr2_info.audio_stream.arg1) {
//  case DXR2_STREAM_AUDIO_AC3: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"audio_0")), TRUE);
//    break; }
//  case DXR2_STREAM_AUDIO_MPEG: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"audio_1")), TRUE);
//    break; }
//  case DXR2_STREAM_AUDIO_LPCM: {
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(property1,"audio_2")), TRUE);
//    break; }
//  }
}


void
on_prop_cancel_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(property1);
}






// ****************************************************************************************
// set all the different options from the properties dialogbox
// ****************************************************************************************
// ******************************************************************************
// Device-path of dvd-device
// ******************************************************************************
void
on_dev_dev_dvd_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  strcpy(tmp_player_info.dvd_device, "/dev/dvd");
}


void
on_dev_dev_cdrom_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  strcpy(tmp_player_info.dvd_device, "/dev/cdrom");
}


void
on_entry3_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
//  strcpy(tmp_player_info.dvd_device, gtk_entry_get_text(GTK_ENTRY(editable)));
}

void
on_hdb_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  strcpy(tmp_player_info.dvd_mountpoint, "/mnt/dvd");
}


void
on_hdc_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  strcpy(tmp_player_info.dvd_mountpoint, "/mnt/cdrom");
}


void
on_hdd_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  strcpy(tmp_player_info.dvd_mountpoint, "/dvd");
}


// eigener eintrag des mountpoints
void
on_entry1_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
//  strcpy(tmp_player_info.dvd_mountpoint, gtk_entry_get_text(GTK_ENTRY(editable)));
}

void
on_tv_0_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.tv_format.arg = DXR2_OUTPUTFORMAT_NTSC;
}


void
on_tv_1_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.tv_format.arg = DXR2_OUTPUTFORMAT_NTSC_60;
}


void
on_tv_2_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.tv_format.arg = DXR2_OUTPUTFORMAT_PAL_M;
}


void
on_tv_3_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.tv_format.arg = DXR2_OUTPUTFORMAT_PAL_M_60;
}


void
on_tv_4_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.tv_format.arg = DXR2_OUTPUTFORMAT_PAL_BDGHI;
}


void
on_tv_5_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.tv_format.arg = DXR2_OUTPUTFORMAT_PAL_N;
}


void
on_tv_6_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.tv_format.arg = DXR2_OUTPUTFORMAT_PAL_Nc;
}


void
on_tv_7_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.tv_format.arg = DXR2_OUTPUTFORMAT_PAL_60;
}

void
on_tv_freq_0_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.video_freq.arg1 = DXR2_SRC_VIDEO_FREQ_30;
}


void
on_tv_freq_1_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.video_freq.arg1 = DXR2_SRC_VIDEO_FREQ_25;
}


void
on_tv_format_0_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.scaling_mode.arg = DXR2_ASPECTRATIOMODE_LETTERBOX;
}


void
on_tv_format_1_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.scaling_mode.arg = DXR2_ASPECTRATIOMODE_NORMAL;
}


void
on_tv_format_2_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.scaling_mode.arg = DXR2_ASPECTRATIOMODE_PAN_SCAN;
}


void
on_sub_0_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.subpicture_stream_id.arg2 = 0;
//  tmp_dxr2_info.subpicture.arg=DXR2_SUBPICTURE_ON;
}


void
on_sub_1_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.subpicture_stream_id.arg2 = 1;
//  tmp_dxr2_info.subpicture.arg=DXR2_SUBPICTURE_ON;
}


void
on_sub_2_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.subpicture_stream_id.arg2 = 2;
//  tmp_dxr2_info.subpicture.arg=DXR2_SUBPICTURE_ON;
}


void
on_sub_3_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.subpicture_stream_id.arg2 = 3;
//  tmp_dxr2_info.subpicture.arg=DXR2_SUBPICTURE_ON;
}


void
on_sub_4_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.subpicture_stream_id.arg2 = 4;
//  tmp_dxr2_info.subpicture.arg=DXR2_SUBPICTURE_ON;
}


void
on_sub_off_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.subpicture_stream_id.arg2 = -1;
//  tmp_dxr2_info.subpicture.arg=DXR2_SUBPICTURE_OFF;
}

void
on_lan_0_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg2 = 0;
}


void
on_lan_1_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg2 = 1;
}


void
on_lan_2_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg2 = 2;
}


void
on_lan_3_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg2 = 3;
}


void
on_lan_4_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg2 = 4;
}


void
on_lan_5_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg2 = 5;
}


void
on_lan_6_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg2 = 6;
}


void
on_lan_7_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg2 = 7;
}


void
on_audio_0_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg1 = DXR2_STREAM_AUDIO_AC3;
}


void
on_audio_1_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg1 = DXR2_STREAM_AUDIO_MPEG;
}


void
on_audio_2_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
//  tmp_dxr2_info.audio_stream.arg1 = DXR2_STREAM_AUDIO_LPCM;
}


void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
//	gtk_widget_destroy(dialog1);
}




void
on_sel_lan_0_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_track ( player_info , 1 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_lan_1_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_track ( player_info , 2 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_lan_2_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_track ( player_info , 3 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_lan_3_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_track ( player_info , 4 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_lan_4_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_track ( player_info , 5 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_lan_5_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_track ( player_info , 6 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_lan_6_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_track ( player_info , 7 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_lan_7_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_track ( player_info , 8 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_sub_0_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_sub ( player_info , 1 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_sub_1_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_sub ( player_info , 2 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_sub_2_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_sub ( player_info , 3 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_sub_3_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_sub ( player_info , 4 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_sub_4_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_sub ( player_info , 5 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_sub_off_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        err = dvd_set_sub ( player_info , -1 ) ;
        if ( err )
                fprintf ( stderr, "%s" , err ) ;
}


void
on_sel_tvout_0_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        pthread_mutex_lock ( & ( player_info -> audio_mutex ) ) ;
        player_info -> default_video_format = 3 ;
        output_set_scaling_mode ( player_info -> out_plugin , 3 ) ;
        pthread_mutex_unlock ( & ( player_info -> audio_mutex ) ) ;
}


void
on_sel_tvout_1_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        pthread_mutex_lock ( & ( player_info -> audio_mutex ) ) ;
        player_info -> default_video_format = 1 ;
        output_set_scaling_mode ( player_info -> out_plugin , 1 ) ;
        pthread_mutex_unlock ( & ( player_info -> audio_mutex ) ) ;
}


void
on_sel_tvout_2_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        pthread_mutex_lock ( & ( player_info -> audio_mutex ) ) ;
        player_info -> default_video_format = 2 ;
        output_set_scaling_mode ( player_info -> out_plugin , 2 ) ;
        pthread_mutex_unlock ( & ( player_info -> audio_mutex ) ) ;
}



//****************************************************************************************
// Volume control (on the fly
//****************************************************************************************
void
on_sel_mute_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
        fprintf ( stderr , "minidxr2 doesn't support this feature yet (please let me know if i'm wrong)\n" ) ;
}

void
on_volume_up_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
        fprintf ( stderr , "minidxr2 doesn't support this feature yet (please let me know if i'm wrong)\n" ) ;

}


void
on_volume_down_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
        fprintf ( stderr , "minidxr2 doesn't support this feature yet (please let me know if i'm wrong)\n" ) ;

}



// ******************************************************************************
// ******************************************************************************
// when showing the 'on_the_fly' properties set the initial values...
// ******************************************************************************
// ******************************************************************************
void
on_on_the_fly_show                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
        GtkLabel *temp_lan ;
        int     position_old = 0;
        int     position = 0 ;
        gchar   *temp_label ;

        temp_label = malloc ( 100 ) ;


        if (( err = dvd_print_audio_info ( player_info , temp_string , BUFFER_LENGTH_1 )) == NULL )
        {

                if ( ( position = new_line_position ( temp_string , position_old ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        gtk_label_set_text ( GTK_LABEL ( lookup_widget ( on_the_fly , "label_track1" ) ) , &temp_label [ 9 ] ) ;

                        position_old = position ;
                }
                if ( ( position = new_line_position ( temp_string , position_old + 2 ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        gtk_label_set_text ( GTK_LABEL ( lookup_widget ( on_the_fly , "label_track2" ) ) , &temp_label [ 10 ] ) ;

                        position_old = position ;
                }
                if ( ( position = new_line_position ( temp_string , position_old + 2 ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        gtk_label_set_text ( GTK_LABEL ( lookup_widget ( on_the_fly , "label_track3" ) ) , &temp_label [ 10 ] ) ;

                        position_old = position ;
                }
                if ( ( position = new_line_position ( temp_string , position_old + 2 ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        gtk_label_set_text ( GTK_LABEL ( lookup_widget ( on_the_fly , "label_track4" ) ) , &temp_label [ 10
                         ] ) ;

                        position_old = position ;
                }
                if ( ( position = new_line_position ( temp_string , position_old + 2 ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        gtk_label_set_text ( GTK_LABEL ( lookup_widget ( on_the_fly , "label_track5" ) ) , &temp_label [ 10
                         ] ) ;

                        position_old = position ;
                }
                if ( ( position = new_line_position ( temp_string , position_old + 2 ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        gtk_label_set_text ( GTK_LABEL ( lookup_widget ( on_the_fly , "label_track6" ) ) , &temp_label [ 10
                         ] ) ;

                        position_old = position ;
                }
                if ( ( position = new_line_position ( temp_string , position_old + 2 ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        gtk_label_set_text ( GTK_LABEL ( lookup_widget ( on_the_fly , "label_track7" ) ) , &temp_label [ 10 ] ) ;

                        position_old = position ;
                }
        }
        else {
                fprintf ( stderr , "%s\n" , err ) ;
        }


        // the same for subpictures....

        position = 0 ;
        position_old = 0 ;
        if (( err = dvd_print_sub_info ( player_info , temp_string , BUFFER_LENGTH_1 )) == NULL )
        {

                if ( ( position = new_line_position ( temp_string , position_old ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        temp_lan = GTK_LABEL ( lookup_widget ( on_the_fly , "label_sub_track1" ) ) ;
                        gtk_label_set_text ( temp_lan , &temp_label [ 9 ] ) ;

                        position_old = position ;
                }
                if ( ( position = new_line_position ( temp_string , position_old + 2 ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        temp_lan = GTK_LABEL ( lookup_widget ( on_the_fly , "label_sub_track2" ) ) ;
                        gtk_label_set_text ( temp_lan , &temp_label [ 10 ] ) ;

                        position_old = position ;
                }
                if ( ( position = new_line_position ( temp_string , position_old + 2 ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        temp_lan = GTK_LABEL ( lookup_widget ( on_the_fly , "label_sub_track3" ) ) ;
                        gtk_label_set_text ( temp_lan , &temp_label [ 10 ] ) ;

                        position_old = position ;
                }
                if ( ( position = new_line_position ( temp_string , position_old + 2 ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        temp_lan = GTK_LABEL ( lookup_widget ( on_the_fly , "label_sub_track4" ) ) ;
                        gtk_label_set_text ( temp_lan , &temp_label [ 10
                         ] ) ;

                        position_old = position ;
                }
                if ( ( position = new_line_position ( temp_string , position_old + 2 ) ) != 0 ) {

                        strncpy ( temp_label , &temp_string [ position_old ] , ( position - position_old ) ) ;
                        temp_label [ position - position_old ] = '\0' ;

                        temp_lan = GTK_LABEL ( lookup_widget ( on_the_fly , "label_sub_track5" ) ) ;
                        gtk_label_set_text ( temp_lan , &temp_label [ 10
                         ] ) ;

                        position_old = position ;
                }

        }
        else {
                fprintf ( stderr , "%s\n" , err ) ;
        }
}


int new_line_position ( char * temp_string, int position )
{
        int c ;

        if ( position ) {
                if ( temp_string [ position - 1 ] == '\0' )
                        return 0 ;
        }

        for ( c = position ; temp_string [ c ] != '\n' ; c ++ ) {
                if ( temp_string [ c ] == '\0' )
                        return c ;
        }
        return c ;
}





// ******************************************************************************
// ******************************************************************************
// play-controls...
// ******************************************************************************
// ******************************************************************************
void
on_pc_title_prev_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
        int temp_int;

        err = dvd_get_chapter ( player_info , &temp_int ) ;
        if ( err )
                fprintf ( stderr , "%s\n" , err ) ;
        else if ( temp_int != 1 ){
                err = dvd_seek_chapter ( player_info , temp_int - 1 ) ;
                if ( err )
                        fprintf ( stderr , "%s\n" , err ) ;
       }
}


void
on_pc_title_next_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
        int temp_int;

        err = dvd_get_chapter ( player_info , &temp_int ) ;
        if ( err )
                fprintf ( stderr , "%s\n" , err ) ;
        else {
                err = dvd_seek_chapter ( player_info , temp_int + 1 ) ;
                if ( err )
                        fprintf ( stderr , "%s\n" , err ) ;
       }
}



void
on_pc_fast_back_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{

        fprintf ( stderr , "Not yet implemented or not supported from minidxr2. Sorry...\n" ) ;
        fflush ( stderr ) ;

}


void
on_pc_fast_forward_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
        err = dvd_ffwd ( player_info ) ;
        if ( err )
                fprintf ( stderr , "%s\n" , err ) ;
}


void
on_pc_single_back_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
        fprintf ( stderr , "Not yet implemented or not supported from minidxr2. Sorry...\n" ) ;
        fflush ( stderr ) ;
}


void
on_pc_single_forward_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
        fprintf ( stderr , "Not yet implemented or not supported from minidxr2. Sorry...\n" ) ;
        fflush ( stderr ) ;
}






// ****************************************************************************************
// programm specific operations
// ****************************************************************************************

void
on_about_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
        about2 = create_about2();
        gtk_widget_show(about2);
}


void
on_dvd_show                            (GtkWidget       *widget,
                                        gpointer         user_data)
{
        player_info = malloc ( sizeof ( player_info_t ) ) ;
        memset ( player_info , 0 , sizeof ( player_info_t ) ) ;

        /* Load in information that cannot be changed
        * (firmware file, mountpoint, etc) and defaults for audio settings */
        err = read_config ( player_info , dxr2_config_file ) ;
        if ( err != NULL )
        {
                 err = read_config ( player_info , alt_config_file ) ;
                 if ( err != NULL )
                 {
                         printf ( "%s: Error reading config file %s: %s\n" ,
                         ANNOUNCE , alt_config_file , err ) ;
                 }
        }

        player_info -> immediate_playback = IP_OFF ;
        player_info -> immediate_playback_files = 0 ;
        player_info -> out_file = NULL ;



        /* Initialize thread stuff. */
      	buf_setup ( player_info ) ;
        ifo_setup ( player_info ) ;
        msg_setup ( player_info ) ;


        err = NULL ;

        output = (output_plugin_fn) dxr2_plugin ;
#ifdef HAVE_X_OVERLAY_SUPPORT
        output = (output_plugin_fn) dxr2_plugin_overlay ;
#endif
				
        player_info -> out_plugin =
        output_setup ( (void *) player_info , output , & err ) ;
        if ( err != NULL )
        {
                fprintf ( stderr , "%s: Error initialising output plugin: %s\n" , ANNOUNCE , err ) ;
        }

        output_css_do_reset ( player_info -> out_plugin ,
        player_info -> dvd_device ) ;

        player_info -> view_mode = OUTPUT_VIEW_OFF ;

        /* Thread setup */
        pthread_attr_init(&thread_attrib);
        pthread_attr_setschedpolicy(&thread_attrib, SCHED_OTHER);

        pthread_create( &read_thread, &thread_attrib, buf_reader , (void*) player_info);
        pthread_create( &write_thread, &thread_attrib, buf_writer , (void*) player_info);


        player_info -> h_state = DVD_UNLOADED ;
#ifdef HAVE_X_OVERLAY_SUPPORT
        err = dvd_initialise_overlay ( player_info , & player_info -> default_colour_key ) ;
        if ( err == NULL )
        {
        err = dvd_set_view_mode ( player_info , OUTPUT_VIEW_WINDOW ) ;
        } else
                fprintf ( stdout, "%s\n", err ) ;

#endif

//        popup_menu = create_menu1 ( ) ;
//        gtk_menu_popup ( popup_menu , NULL , NULL , NULL , NULL , NULL ) ;
}


void
on_exit_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
        err = dvd_quit ( player_info ) ;
        if ( err )
                fprintf(stderr, "%s\n", err);

        output_deinitialise ( player_info -> out_plugin ) ;

        pthread_join(read_thread, NULL);
        pthread_join(write_thread, NULL);

        exit_prog();
}


void exit_prog()
{
        // wait until threads have finished
        pthread_join(read_thread, NULL);
        pthread_join(write_thread, NULL);

        gtk_main_quit();
}



// ****************************************************************************************
// popup specific functions
// ****************************************************************************************

void
on_language_1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_2_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_3_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_4_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_5_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_6_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_7_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_8_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_9_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_10_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_11_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_language_12_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_off1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_letterbox1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_normal1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_pan_scan1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_mpeg1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_ac1_activate                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_lpcm1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


// ****************************************************************************************
// timebar specific functions
// ****************************************************************************************

gboolean
on_timebar_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
        GtkWidget *p_scale;
        GtkAdjustment *p_adj;

        p_scale = GTK_WIDGET( gtk_object_get_data( GTK_OBJECT(
                                  play_control ), "timebar" ) );
        p_adj = gtk_range_get_adjustment ( GTK_RANGE( p_scale ) );

        err = dvd_seek_time ( player_info , (int) p_adj->value / 60 , (int) p_adj->value % 60 , 0 ) ;
        if ( err )
                fprintf ( stderr , "%s\n" , err ) ;

        /* Gtv does it this way. Why not. */
        gtk_range_set_adjustment ( GTK_RANGE( p_scale ), p_adj );
        gtk_range_slider_update ( GTK_RANGE( p_scale ) );
        gtk_range_clear_background ( GTK_RANGE( p_scale ) );
        gtk_range_draw_background ( GTK_RANGE( p_scale ) );

        timebar_timeout_id = gtk_timeout_add ( 500, update_timebar , temp ) ;

        return FALSE;

}


gint update_timebar ( gpointer temp )
{
        GtkWidget *p_scale;
        GtkAdjustment *p_adj;

        p_scale = GTK_WIDGET( gtk_object_get_data( GTK_OBJECT(
                                  play_control ), "timebar" ) );
        p_adj = gtk_range_get_adjustment ( GTK_RANGE( p_scale ) );


        err = dvd_get_time_code ( player_info , temp_string , 79 ) ;
        if ( err )
                fprintf ( stderr , "%s\n" , err ) ;
        else {
                p_adj->value = ( atoi ( ( char * ) &temp_string [ 0 ] ) * 60 )    +    ( atoi ( ( char * ) &temp_string [ 2 ] ) ) ;

                /* Gtv does it this way. Why not. */
                gtk_range_set_adjustment ( GTK_RANGE( p_scale ), p_adj );
                gtk_range_slider_update ( GTK_RANGE( p_scale ) );
                gtk_range_clear_background ( GTK_RANGE( p_scale ) );
                gtk_range_draw_background ( GTK_RANGE( p_scale ) );
        }

        return (TRUE);
}


gboolean
on_timebar_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
        gtk_timeout_remove ( timebar_timeout_id ) ;
        return FALSE;
}


