#include <gnome.h>
#include <errno.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>

#include "player.h"
#include "file/interface.h"
#include "dxr2/interface.h"
#include "player.h"
#include "control.h"
#include "buffer.h"
#include "output.h"
#include "ifo_parse.h"
#include "read_config.h"
#include "message.h"
#include "device.h"



gint update_timebar ( gpointer ) ;
// helps to cut multiple line-strings into single lines
int new_line_position ( char * temp_string , int position ) ;
void refreshFileList(gchar * dirName);
void exit_prog(void);
void file_open(void);


void
on_settings_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_exit_clicked                        (GtkButton       *button,
                                        gpointer         user_data);

void
on_play_clicked                        (GtkButton       *button,
                                        gpointer         user_data);

void
on_stop_clicked                        (GtkButton       *button,
                                        gpointer         user_data);

void
on_entry1_changed                      (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_prop_ok_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_prop_apply_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_prop_cancel_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_hdb_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_hdc_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_hdd_toggled                         (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_0_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_1_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_2_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_3_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_4_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_5_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_6_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_7_toggled                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_freq_0_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_freq_1_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_format_0_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_format_1_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_tv_format_2_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_lan_0_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sub_0_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sub_1_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sub_2_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sub_3_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sub_4_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_lan_0_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_lan_1_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_lan_2_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_lan_3_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_lan_4_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_lan_5_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_lan_6_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_lan_7_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_audio_0_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_audio_1_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_audio_2_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_dvd_show                            (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_property1_show                      (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_sub_off_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_dev_dev_dvd_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);


void
on_dev_dev_cdrom_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_entry3_changed                      (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_sel_lan_0_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_lan_1_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_lan_2_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_lan_3_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_lan_4_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_lan_5_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_lan_6_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_lan_7_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_sub_0_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_sub_1_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_sub_2_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_sub_3_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_sub_4_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_sub_off_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_mute_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_tvout_0_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_tvout_1_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_sel_tvout_2_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_on_the_fly_show                     (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_about_clicked                       (GtkButton       *button,
                                        gpointer         user_data);

void
on_pc_title_prev_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_pc_title_next_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_timebar_drag_end                    (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data);

void
on_pc_fast_back_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_pc_fast_forward_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_pc_single_back_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_pc_single_forward_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_titles_en_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_pause_button_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_overlay_on_off_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_volume_up_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_volume_down_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_eject_dvd_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_reload_dvd_clicked                  (GtkButton       *button,
                                        gpointer         user_data);




/*********************************************************************************************
* functions for the timebar
*********************************************************************************************/
gboolean
on_timebar_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_timebar_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);



/*********************************************************************************************
* functions for the popup menu
*********************************************************************************************/
void
on_language_1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_2_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_3_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_4_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_5_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_6_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_7_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_8_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_9_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_10_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_11_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_language_12_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_off1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_letterbox1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_normal1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_pan_scan1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_mpeg1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_ac1_activate                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_lpcm1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

