/*
 * Minidxr2 - Linux DVD player. Mostly (C) Jack Whitham, 2001
 *
 */
#ifndef CONTROL_H
#define CONTROL_H

#include "player.h"
#include "output.h"

#define DVD_UNLOADED					1
#define DVD_STOPPED						2
#define DVD_QUIT						3
#define DVD_PLAYING						4
#define DVD_PAUSED						5
#define DVD_FAST_FORWARD				6

#define JUMP_DISTANCE			8000		/* about 20s */
#define FFWD_JUMP_DISTANCE		20000		
#define MAX_FILES				128

char * dvd_ffwd ( player_info_t * player_info ) ;
int dvd_open_file ( player_info_t * player_info , char ** file_list , int num_files ,
			char * error , int max_chars ) ;
int dvd_open_title ( player_info_t * player_info , int title ,
			char * error , int max_chars ) ;
char * dvd_get_chapter ( player_info_t * player_info , int * output ) ;
char * dvd_get_length ( player_info_t * player_info , int * output ) ;
char * dvd_get_position ( player_info_t * player_info , int * output ) ;
char * dvd_get_time_code ( player_info_t * player_info , char * output , int max_chars ) ;
char * dvd_pause ( player_info_t * player_info ) ;
char * dvd_play ( player_info_t * player_info ) ;
char * dvd_print_audio_info ( player_info_t * player_info , char * output , int max_chars ) ;
char * dvd_print_chapter_info ( player_info_t * player_info , char * output , int max_chars ) ;
char * dvd_print_sub_info ( player_info_t * player_info , char * output , int max_chars ) ;
char * dvd_print_total_time ( player_info_t * player_info , char * output , int max_chars ) ;
char * dvd_quit ( player_info_t * player_info ) ;
char * dvd_seek_chapter ( player_info_t * player_info , int param_int ) ;
char * dvd_seek_position ( player_info_t * player_info , int param_int ) ;
char * dvd_seek_time ( player_info_t * player_info , int hour , int min , int sec ) ;
char * dvd_set_angle ( player_info_t * player_info , int angle ) ;
char * dvd_set_sub ( player_info_t * player_info , int sub ) ;
char * dvd_set_track ( player_info_t * player_info , int track ) ;
char * dvd_stop ( player_info_t * player_info ) ;
char * dvd_unload ( player_info_t * player_info ) ;
char * dvd_set_default_audio_format ( player_info_t * player_info , int af ) ;
char * dvd_set_default_audio_width ( player_info_t * player_info , int af ) ;
char * dvd_set_default_audio_freq ( player_info_t * player_info , int af ) ;
int dvd_get_message ( player_info_t * p , int * code , char ** data ) ;
char * dvd_list_languages ( void ) ;
int dvd_find_best_sub_track ( player_info_t * player_info , char * codes ) ;
int dvd_find_best_audio_track ( player_info_t * player_info , char * codes ) ;
char * dvd_set_view_mode ( player_info_t * player_info , int mode ) ;
char * dvd_initialise_overlay ( player_info_t * player_info , output_extra_info * ck ) ;

#endif

