/*
 * Minidxr2 - Linux DVD player. Mostly (C) Jack Whitham, 2001
 *
 */
#include <config.h>
#ifdef HAVE_DXR2


#include <sys/types.h>
#include <dxr2ioctl.h>
#include "dxr2-api.h"
#include "output.h"
#include "setup.h"
#include "css.h"
#include "interface.h"




static void common_init ( output_plugin * o )
{
	o -> decryption_switch = (output_control_fn_1_args) dxr2_decryption_switch_ext ;
	o -> fast_forwards = (output_control_fn_1_args) dxr2_fast_forwards_ext ;
	o -> get_playmode = (output_control_fn_0_args) dxr2_get_playmode_ext ;
	o -> mute = (output_control_fn_1_args) dxr2_mute_ext ;
	o -> reset = (output_control_fn_0_args) dxr2_reset ;	 		
	o -> select_audio = (output_control_fn_2_args) dxr2_select_audio_ext ;
	o -> select_subpicture = (output_control_fn_1_args) dxr2_select_subpicture ;
	o -> set_audio_freq = (output_control_fn_1_args) dxr2_set_audio_freq_ext ;
	o -> set_audio_width = (output_control_fn_1_args) dxr2_set_audio_width_ext ;
	o -> set_playmode = (output_control_fn_1_args) dxr2_set_playmode_ext ;
	o -> subpicture = (output_control_fn_1_args) dxr2_subpicture_ext ;
	o -> do_write = (output_write_fn) dxr2_write ;
	o -> do_ioctl = (output_ioctl_fn) dxr2_ioctl ;
	o -> do_initialise = (output_initialise_fn) dxr2_setup ;
	o -> do_deinitialise = (output_deinitialise_fn) dxr2_deinitialise ;
	o -> do_css_finish = (output_css_finish_fn) dxr2_css_finish ;
	o -> do_css_authenticate = (output_css_auth_fn) dxr2_css_authenticate ;
	o -> do_css_do_disc_key = (output_css_disc_fn) dxr2_css_do_disc_key ;
	o -> do_css_do_title_key = (output_css_title_fn) dxr2_css_do_title_key ;
	o -> do_css_reset = (output_css_reset_fn) dxr2_css_reset ;
	o -> set_subpicture_palette = (output_control_fn_1_args) dxr2_set_subpicture_palette ;

	o -> set_video_type = (output_control_fn_1_args) dxr2_set_video_type_ext ;
	o -> set_scaling_mode = (output_control_fn_1_args) dxr2_set_scaling_mode_ext ;
}

/*
 * Get the output plugin definition for the Dxr2 
 *
 */

int dxr2_plugin ( output_plugin * o )
{
	common_init ( o ) ;

	return 1 ;
}

int dxr2_plugin_overlay ( output_plugin * o )
{
	common_init ( o ) ;

#ifdef HAVE_X_OVERLAY_SUPPORT
	o -> do_set_view_mode = (output_set_view_mode_fn) dxr2_set_view_mode ;
	o -> do_initialise_overlay = (output_initialise_overlay_fn) dxr2_initialise_overlay ;
#endif

	return 1 ;
}

#endif

