#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "callbacks.h"
#include "gui_iface.h"
#include "support.h"

GtkWidget*
create_dvd (void)
{
  GtkWidget *dvd;
  GtkWidget *dock1;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *settings;
  GtkWidget *exit;
  GtkWidget *about;
  GtkWidget *vbox1;
  GtkWidget *label30;
  GtkWidget *hbox1;
  guint play_key;
  GtkWidget *play;
  guint pause_button_key;
  GtkWidget *pause_button;
  guint stop_key;
  GtkWidget *stop;
  GtkWidget *hseparator2;
  GtkWidget *hbox2;
  GtkWidget *overlay_on_off;
  guint eject_dvd_key;
  GtkWidget *eject_dvd;
  guint reload_dvd_key;
  GtkWidget *reload_dvd;
  GtkWidget *appbar1;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  dvd = gnome_app_new ("dxr2GUI", _("Dxr2GUI"));
  gtk_object_set_data (GTK_OBJECT (dvd), "dvd", dvd);

  dock1 = GNOME_APP (dvd)->dock;
  gtk_widget_ref (dock1);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "dock1", dock1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dock1);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar1);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "toolbar1", toolbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar1);
  gnome_app_add_toolbar (GNOME_APP (dvd), GTK_TOOLBAR (toolbar1), "toolbar1",
                                GNOME_DOCK_ITEM_BEH_EXCLUSIVE,
                                GNOME_DOCK_TOP, 0, 0, 0);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (toolbar1), 16);
  gtk_toolbar_set_space_style (GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_SPACE_LINE);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar1), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (dvd, GNOME_STOCK_PIXMAP_PREFERENCES);
  settings = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Settings"),
                                _("Change Settings"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (settings);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "settings", settings,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar1));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (dvd, GNOME_STOCK_PIXMAP_EXIT);
  exit = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Exit"),
                                _("Exit Programm and Stop DVD Playback"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (exit);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "exit", exit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (exit);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar1));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (dvd, GNOME_STOCK_PIXMAP_ABOUT);
  about = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("About"),
                                _("About Dialog"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (about);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "about", about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gnome_app_set_contents (GNOME_APP (dvd), vbox1);

  label30 = gtk_label_new (_("Play Control"));
  gtk_widget_ref (label30);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "label30", label30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label30);
  gtk_box_pack_start (GTK_BOX (vbox1), label30, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label30), GTK_JUSTIFY_LEFT);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);

  play = gtk_button_new_with_label ("");
  play_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (play)->child),
                                   _("_Play"));
  gtk_widget_add_accelerator (play, "clicked", accel_group,
                              play_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (play);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "play", play,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (play);
  gtk_box_pack_start (GTK_BOX (hbox1), play, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, play, _("Start the Movie"), NULL);
  gtk_button_set_relief (GTK_BUTTON (play), GTK_RELIEF_NONE);

  pause_button = gtk_button_new_with_label ("");
  pause_button_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (pause_button)->child),
                                   _("P_ause"));
  gtk_widget_add_accelerator (pause_button, "clicked", accel_group,
                              pause_button_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (pause_button);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "pause_button", pause_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pause_button);
  gtk_box_pack_start (GTK_BOX (hbox1), pause_button, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, pause_button, _("Pause Playback"), NULL);
  gtk_button_set_relief (GTK_BUTTON (pause_button), GTK_RELIEF_NONE);

  stop = gtk_button_new_with_label ("");
  stop_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (stop)->child),
                                   _("_Stop"));
  gtk_widget_add_accelerator (stop, "clicked", accel_group,
                              stop_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (stop);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "stop", stop,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (stop);
  gtk_box_pack_start (GTK_BOX (hbox1), stop, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, stop, _("Stop Playback"), NULL);
  gtk_button_set_relief (GTK_BUTTON (stop), GTK_RELIEF_NONE);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator2);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "hseparator2", hseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator2, TRUE, TRUE, 0);

  hbox2 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 0);

  overlay_on_off = gtk_toggle_button_new_with_label (_("overlay on/off"));
  gtk_widget_ref (overlay_on_off);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "overlay_on_off", overlay_on_off,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (overlay_on_off);
  gtk_box_pack_start (GTK_BOX (hbox2), overlay_on_off, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, overlay_on_off, _("Enable / Disable Overlay"), NULL);
  gtk_button_set_relief (GTK_BUTTON (overlay_on_off), GTK_RELIEF_NONE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (overlay_on_off), TRUE);

  eject_dvd = gtk_button_new_with_label ("");
  eject_dvd_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (eject_dvd)->child),
                                   _("E_ject DVD"));
  gtk_widget_add_accelerator (eject_dvd, "clicked", accel_group,
                              eject_dvd_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (eject_dvd);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "eject_dvd", eject_dvd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (eject_dvd);
  gtk_box_pack_start (GTK_BOX (hbox2), eject_dvd, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (eject_dvd), GTK_RELIEF_NONE);

  reload_dvd = gtk_button_new_with_label ("");
  reload_dvd_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (reload_dvd)->child),
                                   _("_Reload DVD"));
  gtk_widget_add_accelerator (reload_dvd, "clicked", accel_group,
                              reload_dvd_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (reload_dvd);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "reload_dvd", reload_dvd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reload_dvd);
  gtk_box_pack_start (GTK_BOX (hbox2), reload_dvd, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (reload_dvd), GTK_RELIEF_NONE);

  appbar1 = gnome_appbar_new (TRUE, TRUE, GNOME_PREFERENCES_NEVER);
  gtk_widget_ref (appbar1);
  gtk_object_set_data_full (GTK_OBJECT (dvd), "appbar1", appbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (appbar1);
  gnome_app_set_statusbar (GNOME_APP (dvd), appbar1);

  gtk_signal_connect (GTK_OBJECT (dvd), "show",
                      GTK_SIGNAL_FUNC (on_dvd_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (settings), "clicked",
                      GTK_SIGNAL_FUNC (on_settings_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (exit), "clicked",
                      GTK_SIGNAL_FUNC (on_exit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (about), "clicked",
                      GTK_SIGNAL_FUNC (on_about_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (play), "clicked",
                      GTK_SIGNAL_FUNC (on_play_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (pause_button), "clicked",
                      GTK_SIGNAL_FUNC (on_pause_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (stop), "clicked",
                      GTK_SIGNAL_FUNC (on_stop_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (overlay_on_off), "toggled",
                      GTK_SIGNAL_FUNC (on_overlay_on_off_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (eject_dvd), "clicked",
                      GTK_SIGNAL_FUNC (on_eject_dvd_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (reload_dvd), "clicked",
                      GTK_SIGNAL_FUNC (on_reload_dvd_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (dvd), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (dvd), accel_group);

  return dvd;
}

GtkWidget*
create_property1 (void)
{
  GtkWidget *property1;
  GtkWidget *dialog_vbox1;
  GtkWidget *notebook2;
  GtkWidget *hbox7;
  GtkWidget *vbox6;
  GtkWidget *label7;
  GSList *vbox6_group = NULL;
  GtkWidget *mount_mnt_dvd;
  GtkWidget *mount_mnt_cdrom;
  GtkWidget *mount_dvd;
  GtkWidget *hseparator5;
  GtkWidget *label8;
  GtkWidget *entry2;
  GtkWidget *vbox13;
  GtkWidget *label23;
  GSList *vbox13_group = NULL;
  GtkWidget *dev_dev_dvd;
  GtkWidget *dev_dev_cdrom;
  GtkWidget *hseparator4;
  GtkWidget *label24;
  GtkWidget *entry3;
  GtkWidget *label9;
  GtkWidget *hbox8;
  GtkWidget *vbox7;
  GtkWidget *label10;
  GSList *vbox7_group = NULL;
  GtkWidget *tv_0;
  guint tv_1_key;
  GtkWidget *tv_1;
  GtkWidget *tv_2;
  GtkWidget *tv_3;
  GtkWidget *tv_4;
  GtkWidget *tv_5;
  GtkWidget *tv_6;
  GtkWidget *tv_7;
  GtkWidget *vbox8;
  GtkWidget *label11;
  GSList *vbox8_group = NULL;
  GtkWidget *tv_freq_0;
  GtkWidget *tv_freq_1;
  GtkWidget *vbox9;
  GtkWidget *label12;
  GSList *vbox9_group = NULL;
  GtkWidget *tv_format_0;
  GtkWidget *tv_format_1;
  GtkWidget *tv_format_2;
  GtkWidget *label13;
  GtkWidget *hbox10;
  GtkWidget *vbox12;
  GtkWidget *label18;
  GSList *audiotype_group = NULL;
  GtkWidget *audio_0;
  GtkWidget *audio_1;
  GtkWidget *audio_2;
  GtkWidget *label17;
  GtkWidget *dialog_action_area1;
  GtkWidget *prop_ok;
  GtkWidget *prop_apply;
  GtkWidget *prop_cancel;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  property1 = gnome_dialog_new (_("DXR2GUI-Settings"), NULL);
  gtk_object_set_data (GTK_OBJECT (property1), "property1", property1);
  GTK_WINDOW (property1)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_modal (GTK_WINDOW (property1), TRUE);
  gtk_window_set_policy (GTK_WINDOW (property1), FALSE, FALSE, FALSE);

  dialog_vbox1 = GNOME_DIALOG (property1)->vbox;
  gtk_object_set_data (GTK_OBJECT (property1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  notebook2 = gtk_notebook_new ();
  gtk_widget_ref (notebook2);
  gtk_object_set_data_full (GTK_OBJECT (property1), "notebook2", notebook2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), notebook2, TRUE, TRUE, 0);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (property1), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox7);
  gtk_container_add (GTK_CONTAINER (notebook2), hbox7);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (property1), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox6, TRUE, TRUE, 0);

  label7 = gtk_label_new (_("Mountpoint of your DVD"));
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (vbox6), label7, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);

  mount_mnt_dvd = gtk_radio_button_new_with_label (vbox6_group, _("/mnt/dvd"));
  vbox6_group = gtk_radio_button_group (GTK_RADIO_BUTTON (mount_mnt_dvd));
  gtk_widget_ref (mount_mnt_dvd);
  gtk_object_set_data_full (GTK_OBJECT (property1), "mount_mnt_dvd", mount_mnt_dvd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mount_mnt_dvd);
  gtk_box_pack_start (GTK_BOX (vbox6), mount_mnt_dvd, FALSE, FALSE, 0);

  mount_mnt_cdrom = gtk_radio_button_new_with_label (vbox6_group, _("/mnt/cdrom"));
  vbox6_group = gtk_radio_button_group (GTK_RADIO_BUTTON (mount_mnt_cdrom));
  gtk_widget_ref (mount_mnt_cdrom);
  gtk_object_set_data_full (GTK_OBJECT (property1), "mount_mnt_cdrom", mount_mnt_cdrom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mount_mnt_cdrom);
  gtk_box_pack_start (GTK_BOX (vbox6), mount_mnt_cdrom, FALSE, FALSE, 0);

  mount_dvd = gtk_radio_button_new_with_label (vbox6_group, _("/dvd"));
  vbox6_group = gtk_radio_button_group (GTK_RADIO_BUTTON (mount_dvd));
  gtk_widget_ref (mount_dvd);
  gtk_object_set_data_full (GTK_OBJECT (property1), "mount_dvd", mount_dvd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mount_dvd);
  gtk_box_pack_start (GTK_BOX (vbox6), mount_dvd, FALSE, FALSE, 0);

  hseparator5 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator5);
  gtk_object_set_data_full (GTK_OBJECT (property1), "hseparator5", hseparator5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator5);
  gtk_box_pack_start (GTK_BOX (vbox6), hseparator5, FALSE, FALSE, 0);

  label8 = gtk_label_new (_("...or type it (eg: /mnt/dvd2)"));
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_box_pack_start (GTK_BOX (vbox6), label8, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label8), GTK_JUSTIFY_LEFT);

  entry2 = gtk_entry_new ();
  gtk_widget_ref (entry2);
  gtk_object_set_data_full (GTK_OBJECT (property1), "entry2", entry2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry2);
  gtk_box_pack_start (GTK_BOX (vbox6), entry2, FALSE, FALSE, 0);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox13);
  gtk_object_set_data_full (GTK_OBJECT (property1), "vbox13", vbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox13);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox13, TRUE, TRUE, 0);

  label23 = gtk_label_new (_("Devicename of your dvd"));
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_box_pack_start (GTK_BOX (vbox13), label23, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label23), GTK_JUSTIFY_LEFT);

  dev_dev_dvd = gtk_radio_button_new_with_label (vbox13_group, _("/dev/dvd"));
  vbox13_group = gtk_radio_button_group (GTK_RADIO_BUTTON (dev_dev_dvd));
  gtk_widget_ref (dev_dev_dvd);
  gtk_object_set_data_full (GTK_OBJECT (property1), "dev_dev_dvd", dev_dev_dvd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dev_dev_dvd);
  gtk_box_pack_start (GTK_BOX (vbox13), dev_dev_dvd, FALSE, FALSE, 0);

  dev_dev_cdrom = gtk_radio_button_new_with_label (vbox13_group, _("/dev/cdrom"));
  vbox13_group = gtk_radio_button_group (GTK_RADIO_BUTTON (dev_dev_cdrom));
  gtk_widget_ref (dev_dev_cdrom);
  gtk_object_set_data_full (GTK_OBJECT (property1), "dev_dev_cdrom", dev_dev_cdrom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dev_dev_cdrom);
  gtk_box_pack_start (GTK_BOX (vbox13), dev_dev_cdrom, FALSE, FALSE, 0);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator4);
  gtk_object_set_data_full (GTK_OBJECT (property1), "hseparator4", hseparator4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator4);
  gtk_box_pack_start (GTK_BOX (vbox13), hseparator4, FALSE, FALSE, 0);

  label24 = gtk_label_new (_("...or type it (eg: /dev/dvd2"));
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_box_pack_start (GTK_BOX (vbox13), label24, FALSE, FALSE, 0);

  entry3 = gtk_entry_new ();
  gtk_widget_ref (entry3);
  gtk_object_set_data_full (GTK_OBJECT (property1), "entry3", entry3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry3);
  gtk_box_pack_start (GTK_BOX (vbox13), entry3, FALSE, FALSE, 0);

  label9 = gtk_label_new (_("DVD Device"));
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook2), 0), label9);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox8);
  gtk_object_set_data_full (GTK_OBJECT (property1), "hbox8", hbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox8);
  gtk_container_add (GTK_CONTAINER (notebook2), hbox8);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (property1), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_box_pack_start (GTK_BOX (hbox8), vbox7, TRUE, TRUE, 0);

  label10 = gtk_label_new (_("TV System"));
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (vbox7), label10, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label10), GTK_JUSTIFY_LEFT);

  tv_0 = gtk_radio_button_new_with_label (vbox7_group, _("NTSC (US)"));
  vbox7_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_0));
  gtk_widget_ref (tv_0);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_0", tv_0,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_0);
  gtk_box_pack_start (GTK_BOX (vbox7), tv_0, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tv_0), TRUE);

  tv_1 = gtk_radio_button_new_with_label (vbox7_group, "");
  tv_1_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (tv_1)->child),
                                   _("NTSC_60"));
  gtk_widget_add_accelerator (tv_1, "clicked", accel_group,
                              tv_1_key, GDK_MOD1_MASK, 0);
  vbox7_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_1));
  gtk_widget_ref (tv_1);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_1", tv_1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_1);
  gtk_box_pack_start (GTK_BOX (vbox7), tv_1, FALSE, FALSE, 0);

  tv_2 = gtk_radio_button_new_with_label (vbox7_group, _("PAL-M"));
  vbox7_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_2));
  gtk_widget_ref (tv_2);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_2", tv_2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_2);
  gtk_box_pack_start (GTK_BOX (vbox7), tv_2, FALSE, FALSE, 0);

  tv_3 = gtk_radio_button_new_with_label (vbox7_group, _("PAL-M-60"));
  vbox7_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_3));
  gtk_widget_ref (tv_3);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_3", tv_3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_3);
  gtk_box_pack_start (GTK_BOX (vbox7), tv_3, FALSE, FALSE, 0);

  tv_4 = gtk_radio_button_new_with_label (vbox7_group, _("PAL-BDGHI (Europe)"));
  vbox7_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_4));
  gtk_widget_ref (tv_4);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_4", tv_4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_4);
  gtk_box_pack_start (GTK_BOX (vbox7), tv_4, FALSE, FALSE, 0);

  tv_5 = gtk_radio_button_new_with_label (vbox7_group, _("PAL-N"));
  vbox7_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_5));
  gtk_widget_ref (tv_5);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_5", tv_5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_5);
  gtk_box_pack_start (GTK_BOX (vbox7), tv_5, FALSE, FALSE, 0);

  tv_6 = gtk_radio_button_new_with_label (vbox7_group, _("PAL-Nc"));
  vbox7_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_6));
  gtk_widget_ref (tv_6);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_6", tv_6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_6);
  gtk_box_pack_start (GTK_BOX (vbox7), tv_6, FALSE, FALSE, 0);

  tv_7 = gtk_radio_button_new_with_label (vbox7_group, _("PAL-60"));
  vbox7_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_7));
  gtk_widget_ref (tv_7);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_7", tv_7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_7);
  gtk_box_pack_start (GTK_BOX (vbox7), tv_7, FALSE, FALSE, 0);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (property1), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox8);
  gtk_box_pack_start (GTK_BOX (hbox8), vbox8, TRUE, TRUE, 0);

  label11 = gtk_label_new (_("Frequency"));
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_box_pack_start (GTK_BOX (vbox8), label11, FALSE, FALSE, 0);

  tv_freq_0 = gtk_radio_button_new_with_label (vbox8_group, _("30 fps"));
  vbox8_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_freq_0));
  gtk_widget_ref (tv_freq_0);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_freq_0", tv_freq_0,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_freq_0);
  gtk_box_pack_start (GTK_BOX (vbox8), tv_freq_0, FALSE, FALSE, 0);

  tv_freq_1 = gtk_radio_button_new_with_label (vbox8_group, _("25 fps (Europe)"));
  vbox8_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_freq_1));
  gtk_widget_ref (tv_freq_1);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_freq_1", tv_freq_1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_freq_1);
  gtk_box_pack_start (GTK_BOX (vbox8), tv_freq_1, FALSE, FALSE, 0);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (property1), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9);
  gtk_box_pack_start (GTK_BOX (hbox8), vbox9, TRUE, TRUE, 0);

  label12 = gtk_label_new (_("Format"));
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (vbox9), label12, FALSE, FALSE, 0);

  tv_format_0 = gtk_radio_button_new_with_label (vbox9_group, _("Letterbox"));
  vbox9_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_format_0));
  gtk_widget_ref (tv_format_0);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_format_0", tv_format_0,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_format_0);
  gtk_box_pack_start (GTK_BOX (vbox9), tv_format_0, FALSE, FALSE, 0);

  tv_format_1 = gtk_radio_button_new_with_label (vbox9_group, _("Normal"));
  vbox9_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_format_1));
  gtk_widget_ref (tv_format_1);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_format_1", tv_format_1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_format_1);
  gtk_box_pack_start (GTK_BOX (vbox9), tv_format_1, FALSE, FALSE, 0);

  tv_format_2 = gtk_radio_button_new_with_label (vbox9_group, _("Pan/Scan"));
  vbox9_group = gtk_radio_button_group (GTK_RADIO_BUTTON (tv_format_2));
  gtk_widget_ref (tv_format_2);
  gtk_object_set_data_full (GTK_OBJECT (property1), "tv_format_2", tv_format_2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tv_format_2);
  gtk_box_pack_start (GTK_BOX (vbox9), tv_format_2, FALSE, FALSE, 0);

  label13 = gtk_label_new (_("TV Output"));
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook2), 1), label13);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (property1), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_container_add (GTK_CONTAINER (notebook2), hbox10);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (property1), "vbox12", vbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox12);
  gtk_box_pack_start (GTK_BOX (hbox10), vbox12, TRUE, TRUE, 0);

  label18 = gtk_label_new (_("Select Audiotype"));
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_box_pack_start (GTK_BOX (vbox12), label18, FALSE, FALSE, 0);

  audio_0 = gtk_radio_button_new_with_label (audiotype_group, _("AC3"));
  audiotype_group = gtk_radio_button_group (GTK_RADIO_BUTTON (audio_0));
  gtk_widget_ref (audio_0);
  gtk_object_set_data_full (GTK_OBJECT (property1), "audio_0", audio_0,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (audio_0);
  gtk_box_pack_start (GTK_BOX (vbox12), audio_0, FALSE, FALSE, 0);

  audio_1 = gtk_radio_button_new_with_label (audiotype_group, _("MPEG"));
  audiotype_group = gtk_radio_button_group (GTK_RADIO_BUTTON (audio_1));
  gtk_widget_ref (audio_1);
  gtk_object_set_data_full (GTK_OBJECT (property1), "audio_1", audio_1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (audio_1);
  gtk_box_pack_start (GTK_BOX (vbox12), audio_1, FALSE, FALSE, 0);

  audio_2 = gtk_radio_button_new_with_label (audiotype_group, _("LPCM"));
  audiotype_group = gtk_radio_button_group (GTK_RADIO_BUTTON (audio_2));
  gtk_widget_ref (audio_2);
  gtk_object_set_data_full (GTK_OBJECT (property1), "audio_2", audio_2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (audio_2);
  gtk_box_pack_start (GTK_BOX (vbox12), audio_2, FALSE, FALSE, 0);

  label17 = gtk_label_new (_("Other"));
  gtk_widget_ref (label17);
  gtk_object_set_data_full (GTK_OBJECT (property1), "label17", label17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label17);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook2), 2), label17);

  dialog_action_area1 = GNOME_DIALOG (property1)->action_area;
  gtk_object_set_data (GTK_OBJECT (property1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  gnome_dialog_append_button (GNOME_DIALOG (property1), GNOME_STOCK_BUTTON_OK);
  prop_ok = GTK_WIDGET (g_list_last (GNOME_DIALOG (property1)->buttons)->data);
  gtk_widget_ref (prop_ok);
  gtk_object_set_data_full (GTK_OBJECT (property1), "prop_ok", prop_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (prop_ok);
  GTK_WIDGET_SET_FLAGS (prop_ok, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (property1), GNOME_STOCK_BUTTON_APPLY);
  prop_apply = GTK_WIDGET (g_list_last (GNOME_DIALOG (property1)->buttons)->data);
  gtk_widget_ref (prop_apply);
  gtk_object_set_data_full (GTK_OBJECT (property1), "prop_apply", prop_apply,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (prop_apply);
  GTK_WIDGET_SET_FLAGS (prop_apply, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (property1), GNOME_STOCK_BUTTON_CANCEL);
  prop_cancel = GTK_WIDGET (g_list_last (GNOME_DIALOG (property1)->buttons)->data);
  gtk_widget_ref (prop_cancel);
  gtk_object_set_data_full (GTK_OBJECT (property1), "prop_cancel", prop_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (prop_cancel);
  GTK_WIDGET_SET_FLAGS (prop_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (property1), "show",
                      GTK_SIGNAL_FUNC (on_property1_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mount_mnt_dvd), "toggled",
                      GTK_SIGNAL_FUNC (on_hdb_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mount_mnt_cdrom), "toggled",
                      GTK_SIGNAL_FUNC (on_hdc_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mount_dvd), "toggled",
                      GTK_SIGNAL_FUNC (on_hdd_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (entry2), "changed",
                      GTK_SIGNAL_FUNC (on_entry1_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (dev_dev_dvd), "toggled",
                      GTK_SIGNAL_FUNC (on_dev_dev_dvd_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (dev_dev_cdrom), "toggled",
                      GTK_SIGNAL_FUNC (on_dev_dev_cdrom_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (entry3), "changed",
                      GTK_SIGNAL_FUNC (on_entry3_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_0), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_0_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_1), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_1_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_2), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_2_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_3), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_3_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_4), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_4_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_5), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_5_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_6), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_6_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_7), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_7_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_freq_0), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_freq_0_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_freq_1), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_freq_1_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_format_0), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_format_0_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_format_1), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_format_1_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tv_format_2), "toggled",
                      GTK_SIGNAL_FUNC (on_tv_format_2_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (audio_0), "toggled",
                      GTK_SIGNAL_FUNC (on_audio_0_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (audio_1), "toggled",
                      GTK_SIGNAL_FUNC (on_audio_1_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (audio_2), "toggled",
                      GTK_SIGNAL_FUNC (on_audio_2_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (prop_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_prop_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (prop_apply), "clicked",
                      GTK_SIGNAL_FUNC (on_prop_apply_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (prop_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_prop_cancel_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (property1), accel_group);

  return property1;
}

GtkWidget*
create_about2 (void)
{
  const gchar *authors[] = {
    "Raphael Zulliger",
    NULL
  };
  GtkWidget *about2;

  about2 = gnome_about_new ("dxr2GUI", VERSION,
                        _("Copyright: Raphael Zulliger 2000"),
                        authors,
                        _("zulli@izh.ch\nHomepage: members.tripod.de/zulli"),
                        NULL);
  gtk_object_set_data (GTK_OBJECT (about2), "about2", about2);
  gtk_window_set_modal (GTK_WINDOW (about2), TRUE);

  return about2;
}

GtkWidget*
create_on_the_fly (void)
{
  GtkWidget *on_the_fly;
  GtkWidget *hbox12;
  GtkWidget *vbox18;
  GtkWidget *lan_selection;
  GtkWidget *hbox24;
  GSList *sel_lan_group = NULL;
  GtkWidget *sel_lan_0;
  GtkWidget *label_track1;
  GtkWidget *hbox25;
  GtkWidget *sel_lan_1;
  GtkWidget *label_track2;
  GtkWidget *hbox26;
  GtkWidget *sel_lan_2;
  GtkWidget *label_track3;
  GtkWidget *hbox27;
  GtkWidget *sel_lan_3;
  GtkWidget *label_track4;
  GtkWidget *hbox28;
  GtkWidget *sel_lan_4;
  GtkWidget *label_track5;
  GtkWidget *hbox29;
  GtkWidget *sel_lan_5;
  GtkWidget *label_track6;
  GtkWidget *hbox30;
  GtkWidget *sel_lan_6;
  GtkWidget *label_track7;
  GtkWidget *vseparator3;
  GtkWidget *vbox19;
  GtkWidget *label26;
  GtkWidget *hbox31;
  GSList *sel_sub_group = NULL;
  GtkWidget *sel_sub_0;
  GtkWidget *label_sub_track1;
  GtkWidget *hbox32;
  GtkWidget *sel_sub_1;
  GtkWidget *label_sub_track2;
  GtkWidget *hbox33;
  GtkWidget *sel_sub_2;
  GtkWidget *label_sub_track3;
  GtkWidget *hbox34;
  GtkWidget *sel_sub_3;
  GtkWidget *label_sub_track4;
  GtkWidget *hbox35;
  GtkWidget *sel_sub_4;
  GtkWidget *label_sub_track5;
  GtkWidget *hbox36;
  GtkWidget *sel_sub_off;
  GtkWidget *label_sub_track_off;
  GtkWidget *vseparator4;
  GtkWidget *vbox14;
  GtkWidget *label29;
  GSList *vbox14_group = NULL;
  GtkWidget *temp_tvout_letterbox;
  GtkWidget *temp_tvout_normal;
  GtkWidget *temp_tvout_pan;
  GtkWidget *hseparator13;
  GtkWidget *label28;
  GtkWidget *hbox23;
  GtkWidget *volume_mute;
  GtkWidget *vbox20;
  GtkWidget *volume_up;
  GtkWidget *volume_down;

  on_the_fly = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (on_the_fly), "on_the_fly", on_the_fly);
  gtk_window_set_title (GTK_WINDOW (on_the_fly), _("Temporary properties (changes will not be saved)"));
  gtk_window_set_policy (GTK_WINDOW (on_the_fly), FALSE, FALSE, FALSE);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox12);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox12", hbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox12);
  gtk_container_add (GTK_CONTAINER (on_the_fly), hbox12);

  vbox18 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox18);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "vbox18", vbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox18);
  gtk_box_pack_start (GTK_BOX (hbox12), vbox18, TRUE, TRUE, 0);

  lan_selection = gtk_label_new (_("Change Audio Language to ....    "));
  gtk_widget_ref (lan_selection);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "lan_selection", lan_selection,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lan_selection);
  gtk_box_pack_start (GTK_BOX (vbox18), lan_selection, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (lan_selection), GTK_JUSTIFY_LEFT);

  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox24);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox18), hbox24, FALSE, FALSE, 0);

  sel_lan_0 = gtk_radio_button_new_with_label (sel_lan_group, "");
  sel_lan_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_lan_0));
  gtk_widget_ref (sel_lan_0);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_lan_0", sel_lan_0,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_lan_0);
  gtk_box_pack_start (GTK_BOX (hbox24), sel_lan_0, FALSE, FALSE, 0);

  label_track1 = gtk_label_new ("");
  gtk_widget_ref (label_track1);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_track1", label_track1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_track1);
  gtk_box_pack_start (GTK_BOX (hbox24), label_track1, FALSE, FALSE, 0);

  hbox25 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox25);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox25", hbox25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox25);
  gtk_box_pack_start (GTK_BOX (vbox18), hbox25, FALSE, FALSE, 0);

  sel_lan_1 = gtk_radio_button_new_with_label (sel_lan_group, "");
  sel_lan_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_lan_1));
  gtk_widget_ref (sel_lan_1);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_lan_1", sel_lan_1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_lan_1);
  gtk_box_pack_start (GTK_BOX (hbox25), sel_lan_1, FALSE, FALSE, 0);

  label_track2 = gtk_label_new ("");
  gtk_widget_ref (label_track2);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_track2", label_track2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_track2);
  gtk_box_pack_start (GTK_BOX (hbox25), label_track2, FALSE, FALSE, 0);

  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox26);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox26", hbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox26);
  gtk_box_pack_start (GTK_BOX (vbox18), hbox26, FALSE, FALSE, 0);

  sel_lan_2 = gtk_radio_button_new_with_label (sel_lan_group, "");
  sel_lan_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_lan_2));
  gtk_widget_ref (sel_lan_2);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_lan_2", sel_lan_2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_lan_2);
  gtk_box_pack_start (GTK_BOX (hbox26), sel_lan_2, FALSE, FALSE, 0);

  label_track3 = gtk_label_new ("");
  gtk_widget_ref (label_track3);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_track3", label_track3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_track3);
  gtk_box_pack_start (GTK_BOX (hbox26), label_track3, FALSE, FALSE, 0);

  hbox27 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox27);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox27", hbox27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox27);
  gtk_box_pack_start (GTK_BOX (vbox18), hbox27, FALSE, FALSE, 0);

  sel_lan_3 = gtk_radio_button_new_with_label (sel_lan_group, "");
  sel_lan_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_lan_3));
  gtk_widget_ref (sel_lan_3);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_lan_3", sel_lan_3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_lan_3);
  gtk_box_pack_start (GTK_BOX (hbox27), sel_lan_3, FALSE, FALSE, 0);

  label_track4 = gtk_label_new ("");
  gtk_widget_ref (label_track4);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_track4", label_track4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_track4);
  gtk_box_pack_start (GTK_BOX (hbox27), label_track4, FALSE, FALSE, 0);

  hbox28 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox28);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox28", hbox28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox28);
  gtk_box_pack_start (GTK_BOX (vbox18), hbox28, FALSE, FALSE, 0);

  sel_lan_4 = gtk_radio_button_new_with_label (sel_lan_group, "");
  sel_lan_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_lan_4));
  gtk_widget_ref (sel_lan_4);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_lan_4", sel_lan_4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_lan_4);
  gtk_box_pack_start (GTK_BOX (hbox28), sel_lan_4, FALSE, FALSE, 0);

  label_track5 = gtk_label_new ("");
  gtk_widget_ref (label_track5);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_track5", label_track5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_track5);
  gtk_box_pack_start (GTK_BOX (hbox28), label_track5, FALSE, FALSE, 0);

  hbox29 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox29);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox29", hbox29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox29);
  gtk_box_pack_start (GTK_BOX (vbox18), hbox29, FALSE, FALSE, 0);

  sel_lan_5 = gtk_radio_button_new_with_label (sel_lan_group, "");
  sel_lan_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_lan_5));
  gtk_widget_ref (sel_lan_5);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_lan_5", sel_lan_5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_lan_5);
  gtk_box_pack_start (GTK_BOX (hbox29), sel_lan_5, FALSE, FALSE, 0);

  label_track6 = gtk_label_new ("");
  gtk_widget_ref (label_track6);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_track6", label_track6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_track6);
  gtk_box_pack_start (GTK_BOX (hbox29), label_track6, FALSE, FALSE, 0);

  hbox30 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox30);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox30", hbox30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox30);
  gtk_box_pack_start (GTK_BOX (vbox18), hbox30, FALSE, FALSE, 0);

  sel_lan_6 = gtk_radio_button_new_with_label (sel_lan_group, "");
  sel_lan_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_lan_6));
  gtk_widget_ref (sel_lan_6);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_lan_6", sel_lan_6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_lan_6);
  gtk_box_pack_start (GTK_BOX (hbox30), sel_lan_6, FALSE, FALSE, 0);

  label_track7 = gtk_label_new ("");
  gtk_widget_ref (label_track7);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_track7", label_track7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_track7);
  gtk_box_pack_start (GTK_BOX (hbox30), label_track7, FALSE, FALSE, 0);

  vseparator3 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator3);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "vseparator3", vseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator3);
  gtk_box_pack_start (GTK_BOX (hbox12), vseparator3, TRUE, TRUE, 0);

  vbox19 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox19);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "vbox19", vbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox19);
  gtk_box_pack_start (GTK_BOX (hbox12), vbox19, TRUE, TRUE, 0);

  label26 = gtk_label_new (_("Change Subpicture to...   "));
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_box_pack_start (GTK_BOX (vbox19), label26, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label26), GTK_JUSTIFY_LEFT);

  hbox31 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox31);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox31", hbox31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox31);
  gtk_box_pack_start (GTK_BOX (vbox19), hbox31, FALSE, FALSE, 0);

  sel_sub_0 = gtk_radio_button_new_with_label (sel_sub_group, "");
  sel_sub_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_sub_0));
  gtk_widget_ref (sel_sub_0);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_sub_0", sel_sub_0,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_sub_0);
  gtk_box_pack_start (GTK_BOX (hbox31), sel_sub_0, FALSE, FALSE, 0);

  label_sub_track1 = gtk_label_new ("");
  gtk_widget_ref (label_sub_track1);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_sub_track1", label_sub_track1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_sub_track1);
  gtk_box_pack_start (GTK_BOX (hbox31), label_sub_track1, FALSE, FALSE, 0);

  hbox32 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox32);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox32", hbox32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox32);
  gtk_box_pack_start (GTK_BOX (vbox19), hbox32, FALSE, FALSE, 0);

  sel_sub_1 = gtk_radio_button_new_with_label (sel_sub_group, "");
  sel_sub_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_sub_1));
  gtk_widget_ref (sel_sub_1);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_sub_1", sel_sub_1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_sub_1);
  gtk_box_pack_start (GTK_BOX (hbox32), sel_sub_1, FALSE, FALSE, 0);

  label_sub_track2 = gtk_label_new ("");
  gtk_widget_ref (label_sub_track2);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_sub_track2", label_sub_track2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_sub_track2);
  gtk_box_pack_start (GTK_BOX (hbox32), label_sub_track2, FALSE, FALSE, 0);

  hbox33 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox33);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox33", hbox33,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox33);
  gtk_box_pack_start (GTK_BOX (vbox19), hbox33, FALSE, FALSE, 0);

  sel_sub_2 = gtk_radio_button_new_with_label (sel_sub_group, "");
  sel_sub_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_sub_2));
  gtk_widget_ref (sel_sub_2);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_sub_2", sel_sub_2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_sub_2);
  gtk_box_pack_start (GTK_BOX (hbox33), sel_sub_2, FALSE, FALSE, 0);

  label_sub_track3 = gtk_label_new ("");
  gtk_widget_ref (label_sub_track3);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_sub_track3", label_sub_track3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_sub_track3);
  gtk_box_pack_start (GTK_BOX (hbox33), label_sub_track3, FALSE, FALSE, 0);

  hbox34 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox34);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox34", hbox34,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox34);
  gtk_box_pack_start (GTK_BOX (vbox19), hbox34, FALSE, FALSE, 0);

  sel_sub_3 = gtk_radio_button_new_with_label (sel_sub_group, "");
  sel_sub_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_sub_3));
  gtk_widget_ref (sel_sub_3);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_sub_3", sel_sub_3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_sub_3);
  gtk_box_pack_start (GTK_BOX (hbox34), sel_sub_3, FALSE, FALSE, 0);

  label_sub_track4 = gtk_label_new ("");
  gtk_widget_ref (label_sub_track4);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_sub_track4", label_sub_track4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_sub_track4);
  gtk_box_pack_start (GTK_BOX (hbox34), label_sub_track4, FALSE, FALSE, 0);

  hbox35 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox35);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox35", hbox35,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox35);
  gtk_box_pack_start (GTK_BOX (vbox19), hbox35, FALSE, FALSE, 0);

  sel_sub_4 = gtk_radio_button_new_with_label (sel_sub_group, "");
  sel_sub_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_sub_4));
  gtk_widget_ref (sel_sub_4);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_sub_4", sel_sub_4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_sub_4);
  gtk_box_pack_start (GTK_BOX (hbox35), sel_sub_4, FALSE, FALSE, 0);

  label_sub_track5 = gtk_label_new ("");
  gtk_widget_ref (label_sub_track5);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_sub_track5", label_sub_track5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_sub_track5);
  gtk_box_pack_start (GTK_BOX (hbox35), label_sub_track5, FALSE, FALSE, 0);

  hbox36 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox36);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox36", hbox36,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox36);
  gtk_box_pack_start (GTK_BOX (vbox19), hbox36, FALSE, FALSE, 0);

  sel_sub_off = gtk_radio_button_new_with_label (sel_sub_group, "");
  sel_sub_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sel_sub_off));
  gtk_widget_ref (sel_sub_off);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "sel_sub_off", sel_sub_off,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sel_sub_off);
  gtk_box_pack_start (GTK_BOX (hbox36), sel_sub_off, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sel_sub_off), TRUE);

  label_sub_track_off = gtk_label_new (_("off"));
  gtk_widget_ref (label_sub_track_off);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label_sub_track_off", label_sub_track_off,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_sub_track_off);
  gtk_box_pack_start (GTK_BOX (hbox36), label_sub_track_off, FALSE, FALSE, 0);

  vseparator4 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator4);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "vseparator4", vseparator4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator4);
  gtk_box_pack_start (GTK_BOX (hbox12), vseparator4, TRUE, TRUE, 0);

  vbox14 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox14);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "vbox14", vbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox14);
  gtk_box_pack_start (GTK_BOX (hbox12), vbox14, TRUE, TRUE, 0);

  label29 = gtk_label_new (_("TV Format"));
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_box_pack_start (GTK_BOX (vbox14), label29, FALSE, FALSE, 0);

  temp_tvout_letterbox = gtk_radio_button_new_with_label (vbox14_group, _("Letterbox"));
  vbox14_group = gtk_radio_button_group (GTK_RADIO_BUTTON (temp_tvout_letterbox));
  gtk_widget_ref (temp_tvout_letterbox);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "temp_tvout_letterbox", temp_tvout_letterbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (temp_tvout_letterbox);
  gtk_box_pack_start (GTK_BOX (vbox14), temp_tvout_letterbox, FALSE, FALSE, 0);

  temp_tvout_normal = gtk_radio_button_new_with_label (vbox14_group, _("Normal"));
  vbox14_group = gtk_radio_button_group (GTK_RADIO_BUTTON (temp_tvout_normal));
  gtk_widget_ref (temp_tvout_normal);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "temp_tvout_normal", temp_tvout_normal,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (temp_tvout_normal);
  gtk_box_pack_start (GTK_BOX (vbox14), temp_tvout_normal, FALSE, FALSE, 0);

  temp_tvout_pan = gtk_radio_button_new_with_label (vbox14_group, _("Pan/Scan"));
  vbox14_group = gtk_radio_button_group (GTK_RADIO_BUTTON (temp_tvout_pan));
  gtk_widget_ref (temp_tvout_pan);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "temp_tvout_pan", temp_tvout_pan,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (temp_tvout_pan);
  gtk_box_pack_start (GTK_BOX (vbox14), temp_tvout_pan, FALSE, FALSE, 0);

  hseparator13 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator13);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hseparator13", hseparator13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator13);
  gtk_box_pack_start (GTK_BOX (vbox14), hseparator13, TRUE, TRUE, 0);

  label28 = gtk_label_new (_("Volume"));
  gtk_widget_ref (label28);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "label28", label28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (vbox14), label28, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label28), GTK_JUSTIFY_LEFT);

  hbox23 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox23);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "hbox23", hbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox23);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox23, TRUE, TRUE, 0);

  volume_mute = gtk_check_button_new_with_label (_("Mute On/Off "));
  gtk_widget_ref (volume_mute);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "volume_mute", volume_mute,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (hbox23), volume_mute, FALSE, FALSE, 0);

  vbox20 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox20);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "vbox20", vbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox20);
  gtk_box_pack_start (GTK_BOX (hbox23), vbox20, TRUE, TRUE, 0);

  volume_up = gnome_stock_button (GNOME_STOCK_BUTTON_UP);
  gtk_widget_ref (volume_up);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "volume_up", volume_up,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (vbox20), volume_up, TRUE, FALSE, 0);

  volume_down = gnome_stock_button (GNOME_STOCK_BUTTON_DOWN);
  gtk_widget_ref (volume_down);
  gtk_object_set_data_full (GTK_OBJECT (on_the_fly), "volume_down", volume_down,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (vbox20), volume_down, TRUE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (on_the_fly), "show",
                      GTK_SIGNAL_FUNC (on_on_the_fly_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_lan_0), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_lan_0_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_lan_1), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_lan_1_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_lan_2), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_lan_2_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_lan_3), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_lan_3_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_lan_4), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_lan_4_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_lan_5), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_lan_5_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_lan_6), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_lan_6_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_sub_0), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_sub_0_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_sub_1), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_sub_1_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_sub_2), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_sub_2_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_sub_3), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_sub_3_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_sub_4), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_sub_4_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sel_sub_off), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_sub_off_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (temp_tvout_letterbox), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_tvout_0_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (temp_tvout_normal), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_tvout_1_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (temp_tvout_pan), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_tvout_2_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (volume_mute), "toggled",
                      GTK_SIGNAL_FUNC (on_sel_mute_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (volume_up), "clicked",
                      GTK_SIGNAL_FUNC (on_volume_up_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (volume_down), "clicked",
                      GTK_SIGNAL_FUNC (on_volume_down_clicked),
                      NULL);

  return on_the_fly;
}

GtkWidget*
create_play_control (void)
{
  GtkWidget *play_control;
  GtkWidget *vbox17;
  GtkWidget *hbox17;
  GtkWidget *vbox16;
  GtkWidget *label31;
  GtkWidget *hbox18;
  GtkWidget *pc_title_prev;
  GtkWidget *pc_title_next;
  GtkWidget *vseparator2;
  GtkWidget *label34;
  GtkWidget *hbox20;
  guint pc_fast_back_key;
  GtkWidget *pc_fast_back;
  guint pc_fast_forward_key;
  GtkWidget *pc_fast_forward;
  GtkWidget *hseparator11;
  GtkWidget *label35;
  GtkWidget *hbox21;
  GtkWidget *pc_single_back;
  GtkWidget *pc_single_forward;
  GtkWidget *hseparator12;
  GtkWidget *label33;
  GtkWidget *timebar;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  play_control = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (play_control), "play_control", play_control);
  gtk_window_set_title (GTK_WINDOW (play_control), _("play control"));
  gtk_window_set_policy (GTK_WINDOW (play_control), FALSE, FALSE, FALSE);

  vbox17 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox17);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "vbox17", vbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox17);
  gtk_container_add (GTK_CONTAINER (play_control), vbox17);

  hbox17 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox17);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "hbox17", hbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox17);
  gtk_box_pack_start (GTK_BOX (vbox17), hbox17, TRUE, TRUE, 0);

  vbox16 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox16);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "vbox16", vbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox16);
  gtk_box_pack_start (GTK_BOX (hbox17), vbox16, FALSE, FALSE, 0);

  label31 = gtk_label_new (_("Title Control"));
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
  gtk_box_pack_start (GTK_BOX (vbox16), label31, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label31), GTK_JUSTIFY_LEFT);

  hbox18 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox18);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "hbox18", hbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox18);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox18, FALSE, FALSE, 0);

  pc_title_prev = gnome_stock_button (GNOME_STOCK_BUTTON_PREV);
  gtk_widget_ref (pc_title_prev);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "pc_title_prev", pc_title_prev,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pc_title_prev);
  gtk_box_pack_start (GTK_BOX (hbox18), pc_title_prev, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, pc_title_prev, _("Jump to previous nhapter"), NULL);

  pc_title_next = gnome_stock_button (GNOME_STOCK_BUTTON_NEXT);
  gtk_widget_ref (pc_title_next);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "pc_title_next", pc_title_next,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pc_title_next);
  gtk_box_pack_start (GTK_BOX (hbox18), pc_title_next, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, pc_title_next, _("Jump to next chapter"), NULL);

  vseparator2 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator2);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "vseparator2", vseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator2);
  gtk_box_pack_start (GTK_BOX (hbox17), vseparator2, TRUE, TRUE, 0);

  vbox17 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox17);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "vbox17", vbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox17);
  gtk_box_pack_start (GTK_BOX (hbox17), vbox17, TRUE, TRUE, 0);

  label34 = gtk_label_new (_("Fast"));
  gtk_widget_ref (label34);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "label34", label34,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label34);
  gtk_box_pack_start (GTK_BOX (vbox17), label34, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label34), GTK_JUSTIFY_LEFT);

  hbox20 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox20);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "hbox20", hbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox20);
  gtk_box_pack_start (GTK_BOX (vbox17), hbox20, FALSE, FALSE, 0);

  pc_fast_back = gtk_button_new_with_label ("");
  pc_fast_back_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (pc_fast_back)->child),
                                   _("_backward"));
  gtk_widget_add_accelerator (pc_fast_back, "clicked", accel_group,
                              pc_fast_back_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (pc_fast_back);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "pc_fast_back", pc_fast_back,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pc_fast_back);
  gtk_box_pack_start (GTK_BOX (hbox20), pc_fast_back, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, pc_fast_back, _("fast backward"), NULL);
  gtk_button_set_relief (GTK_BUTTON (pc_fast_back), GTK_RELIEF_NONE);

  pc_fast_forward = gtk_button_new_with_label ("");
  pc_fast_forward_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (pc_fast_forward)->child),
                                   _("_forward"));
  gtk_widget_add_accelerator (pc_fast_forward, "clicked", accel_group,
                              pc_fast_forward_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (pc_fast_forward);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "pc_fast_forward", pc_fast_forward,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pc_fast_forward);
  gtk_box_pack_start (GTK_BOX (hbox20), pc_fast_forward, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, pc_fast_forward, _("fast forward"), NULL);
  gtk_button_set_relief (GTK_BUTTON (pc_fast_forward), GTK_RELIEF_NONE);

  hseparator11 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator11);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "hseparator11", hseparator11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator11);
  gtk_box_pack_start (GTK_BOX (vbox17), hseparator11, FALSE, FALSE, 0);

  label35 = gtk_label_new (_("Singlestep"));
  gtk_widget_ref (label35);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "label35", label35,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (vbox17), label35, FALSE, FALSE, 0);

  hbox21 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox21);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "hbox21", hbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox21);
  gtk_box_pack_start (GTK_BOX (vbox17), hbox21, FALSE, FALSE, 0);

  pc_single_back = gtk_button_new_with_label (_("backward"));
  gtk_widget_ref (pc_single_back);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "pc_single_back", pc_single_back,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (hbox21), pc_single_back, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, pc_single_back, _("singlestep backward"), NULL);
  gtk_button_set_relief (GTK_BUTTON (pc_single_back), GTK_RELIEF_NONE);

  pc_single_forward = gtk_button_new_with_label (_("forward"));
  gtk_widget_ref (pc_single_forward);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "pc_single_forward", pc_single_forward,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (hbox21), pc_single_forward, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, pc_single_forward, _("singlestep forward"), NULL);
  gtk_button_set_relief (GTK_BUTTON (pc_single_forward), GTK_RELIEF_NONE);

  hseparator12 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator12);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "hseparator12", hseparator12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator12);
  gtk_box_pack_start (GTK_BOX (vbox17), hseparator12, TRUE, TRUE, 0);

  label33 = gtk_label_new (_("Time Position"));
  gtk_widget_ref (label33);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "label33", label33,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label33);
  gtk_box_pack_start (GTK_BOX (vbox17), label33, TRUE, TRUE, 0);

  timebar = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 0, 1, 10, 0)));
  gtk_widget_ref (timebar);
  gtk_object_set_data_full (GTK_OBJECT (play_control), "timebar", timebar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (timebar);
  gtk_box_pack_start (GTK_BOX (vbox17), timebar, TRUE, TRUE, 0);
  GTK_WIDGET_UNSET_FLAGS (timebar, GTK_CAN_FOCUS);
  GTK_WIDGET_SET_FLAGS (timebar, GTK_CAN_DEFAULT);
  gtk_scale_set_value_pos (GTK_SCALE (timebar), GTK_POS_BOTTOM);
  gtk_scale_set_digits (GTK_SCALE (timebar), 0);

  gtk_signal_connect (GTK_OBJECT (pc_title_prev), "clicked",
                      GTK_SIGNAL_FUNC (on_pc_title_prev_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (pc_title_next), "clicked",
                      GTK_SIGNAL_FUNC (on_pc_title_next_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (pc_fast_back), "clicked",
                      GTK_SIGNAL_FUNC (on_pc_fast_back_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (pc_fast_forward), "clicked",
                      GTK_SIGNAL_FUNC (on_pc_fast_forward_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (pc_single_back), "clicked",
                      GTK_SIGNAL_FUNC (on_pc_single_back_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (pc_single_forward), "clicked",
                      GTK_SIGNAL_FUNC (on_pc_single_forward_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (timebar), "button_release_event",
                      GTK_SIGNAL_FUNC (on_timebar_button_release_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (timebar), "button_press_event",
                      GTK_SIGNAL_FUNC (on_timebar_button_press_event),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (play_control), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (play_control), accel_group);

  return play_control;
}

static GnomeUIInfo audio_language1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("Language 1"),
    NULL,
    (gpointer) on_language_1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Language 2"),
    NULL,
    (gpointer) on_language_2_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Language 3"),
    NULL,
    (gpointer) on_language_3_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Language 4"),
    NULL,
    (gpointer) on_language_4_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Language 5"),
    NULL,
    (gpointer) on_language_5_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Language 6"),
    NULL,
    (gpointer) on_language_6_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Language 7"),
    NULL,
    (gpointer) on_language_7_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo subpicture_language1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("Language 1"),
    NULL,
    (gpointer) on_language_8_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Language 2"),
    NULL,
    (gpointer) on_language_9_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Language 3"),
    NULL,
    (gpointer) on_language_10_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Language 4"),
    NULL,
    (gpointer) on_language_11_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Language 5"),
    NULL,
    (gpointer) on_language_12_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("off"),
    NULL,
    (gpointer) on_off1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo tv_format1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("Letterbox"),
    NULL,
    (gpointer) on_letterbox1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Normal"),
    NULL,
    (gpointer) on_normal1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("Pan/Scan"),
    NULL,
    (gpointer) on_pan_scan1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo audio_format1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("MPEG"),
    NULL,
    (gpointer) on_mpeg1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("AC3"),
    NULL,
    (gpointer) on_ac1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("LPCM"),
    NULL,
    (gpointer) on_lpcm1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo menu1_uiinfo[] =
{
  {
    GNOME_APP_UI_SUBTREE, N_("Audio language"),
    NULL,
    audio_language1_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("Subpicture language"),
    NULL,
    subpicture_language1_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("TV format"),
    NULL,
    tv_format1_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("Audio format"),
    NULL,
    audio_format1_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

GtkWidget*
create_menu1 (void)
{
  GtkWidget *menu1;

  menu1 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (menu1), "menu1", menu1);
  gnome_app_fill_menu (GTK_MENU_SHELL (menu1), menu1_uiinfo,
                       NULL, FALSE, 0);

  gtk_widget_ref (menu1_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "audio_language1",
                            menu1_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (audio_language1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_1",
                            audio_language1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (audio_language1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_2",
                            audio_language1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (audio_language1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_3",
                            audio_language1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (audio_language1_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_4",
                            audio_language1_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (audio_language1_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_5",
                            audio_language1_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (audio_language1_menu_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_6",
                            audio_language1_menu_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (audio_language1_menu_uiinfo[6].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_7",
                            audio_language1_menu_uiinfo[6].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menu1_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "subpicture_language1",
                            menu1_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (subpicture_language1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_8",
                            subpicture_language1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (subpicture_language1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_9",
                            subpicture_language1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (subpicture_language1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_10",
                            subpicture_language1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (subpicture_language1_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_11",
                            subpicture_language1_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (subpicture_language1_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "language_12",
                            subpicture_language1_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (subpicture_language1_menu_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "off1",
                            subpicture_language1_menu_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menu1_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "tv_format1",
                            menu1_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (tv_format1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "letterbox1",
                            tv_format1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (tv_format1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "normal1",
                            tv_format1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (tv_format1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "pan_scan1",
                            tv_format1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menu1_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "audio_format1",
                            menu1_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (audio_format1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "mpeg1",
                            audio_format1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (audio_format1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "ac1",
                            audio_format1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (audio_format1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "lpcm1",
                            audio_format1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  return menu1;
}

