#ifndef __MISC_H__
#define __MISC_H__

#include <stdio.h>
#include <stdarg.h>
#include <bswap.h>
#include "ifo.h"

#define OFFSET_IFO		0x0000
#define OFFSET_VTS		0x0000
#define OFFSET_LEN		0x00C0
#define IFO_OFFSET_TAT		0x00C0
#define OFFSET_VTSI_MAT		0x0080
#define IFO_OFFSET_VIDEO	0x0100
#define IFO_OFFSET_AUDIO	0x0200
#define IFO_OFFSET_SUBPIC	0x0250
#define IFO_OFFSET_FIRST_PGC	0x0400


uint32_t get4bytes (const uint8_t *buf);
uint16_t get2bytes (const uint8_t *buf);

int ifoReadTBL (ifo_t *ifo, off_t offset, uint8_t tbl_id);

#ifndef __LOG
#define __LOG
#define LOG_ERROR               0
#define LOG_WARNING             1
#define LOG_INFO                6
#define LOG_DEBUG               7

#ifdef DEBUG
#define LOG(lvl,args...)\
do {\
fprintf (stderr, "%d\t%s:%s#%d\t", lvl, __FILE__, __FUNCTION__, __LINE__);\
fprintf (stderr, args);\
fprintf (stderr, "\n");\
} while (0)
#else
#define LOG(lvl,args...)\
if (lvl != LOG_DEBUG) {\
fprintf (stderr, "%d\t%s:%s#%d\t", lvl, __FILE__, __FUNCTION__, __LINE__);\
fprintf (stderr, args);\
fprintf (stderr, "\n");\
}
#endif
#endif

#endif
