/*
 * Minidxr2 - Linux DVD player. Mostly (C) Jack Whitham, 2001
 *
 */
#ifndef OUTPUT_CODES_H
#define OUTPUT_CODES_H

/* No two OUTPUT_ #defines can share the same value because
 * they are used as keys in translation tables. (They do not need to
 * be sequential, however) */

#define OUTPUT_CSS_OK						0

/* error codes */
#define OUTPUT_END							-1
#define OUTPUT_CSS_ERROR					-2
#define OUTPUT_CSS_NOT_ENCRYPTED			-3
#define OUTPUT_CSS_NOT_AVAILABLE			-4
#define OUTPUT_NOT_AVAILABLE				-9999

/* play modes */
#define OUTPUT_PLAYMODE_STOPPED				1
#define OUTPUT_PLAYMODE_PAUSED				2
#define OUTPUT_PLAYMODE_SLOWFORWARDS		3
#define OUTPUT_PLAYMODE_SLOWBACKWARDS		4
#define OUTPUT_PLAYMODE_SINGLESTEP			5
#define OUTPUT_PLAYMODE_PLAY				6
#define OUTPUT_PLAYMODE_REVERSEPLAY			7
#define OUTPUT_PLAYMODE_FASTFORWARDS		8
#define OUTPUT_PLAYMODE_FASTBACKWARDS		9

/* audio freq */
#define OUTPUT_AUDIO_FREQ_441				10
#define OUTPUT_AUDIO_FREQ_48				11
#define OUTPUT_AUDIO_FREQ_96				12
#define OUTPUT_AUDIO_FREQ_2205				13
#define OUTPUT_AUDIO_FREQ_32				14

/* audio width */
#define OUTPUT_AUDIO_WIDTH_16				15
#define OUTPUT_AUDIO_WIDTH_20				16
#define OUTPUT_AUDIO_WIDTH_24				17

/* audio type */
#define OUTPUT_AUDIO_AC3 					18
#define OUTPUT_AUDIO_MPEG 					19
#define OUTPUT_AUDIO_LPCM					20

/* video format */
#define OUTPUT_FORMAT_NTSC					21
#define OUTPUT_FORMAT_NTSC_60				22
#define OUTPUT_FORMAT_PAL_M					23
#define OUTPUT_FORMAT_PAL_M_60				24
#define OUTPUT_FORMAT_PAL_BDGHI				25
#define OUTPUT_FORMAT_PAL_N					26
#define OUTPUT_FORMAT_PAL_Nc				27
#define OUTPUT_FORMAT_PAL_60				28

/* video freq */
#define OUTPUT_SRC_VIDEO_FREQ_30			29
#define OUTPUT_SRC_VIDEO_FREQ_25			30

/* video aspect */
#define OUTPUT_ASPECTRATIOMODE_LETTERBOX	31
#define OUTPUT_ASPECTRATIOMODE_NORMAL		32
#define OUTPUT_ASPECTRATIOMODE_PAN_SCAN		33

/* fast forward */
#define OUTPUT_PLAYRATE_2x					34
#define OUTPUT_PLAYRATE_3x					35
#define OUTPUT_PLAYRATE_4x					36
#define OUTPUT_PLAYRATE_5x					37
#define OUTPUT_PLAYRATE_6x					38

/* types of stream - vob or mpeg1 */
#define OUTPUT_TYPE_VOB 					39
#define OUTPUT_TYPE_MPEG 					40

/* output_set_view_mode codes */
#define OUTPUT_VIEW_OFF						41
#define OUTPUT_VIEW_FULLSCREEN				42
#define OUTPUT_VIEW_WINDOW					43

#endif

