/*
 * Minidxr2 - Linux DVD player. Mostly (C) Jack Whitham, 2001
 *
 */
#ifndef PARSER_H
#define PARSER_H

#define STRING							1
#define INTEGER							2
#define NONE							3
#define TABLE							4
#define INT_RANGE						5

typedef struct parser_table_struct {
				char	key [ 23 ] ;
				void	* data ;
				void	* data2 ;
				char	type ;
		} parser_table ;

/* returns the type of the record found, or zero */
/* allow 128 bytes for the error_buffer */
int parse_type ( char * input , parser_table * t ,
		void ** output_data , void ** output_data_2 , char * name , char * error_buffer ) ;

/* The reverse of the above function. This is intended for the
 * specific situation where the actual key is stored as an integer in the
 * data field. It returns the key field of the record found. */
int parse_reverse ( int input , parser_table * t ,
		char ** output_data , char * name , char * error_buffer ) ;

void remove_whitespace ( char * str ) ;

int parse_file_list ( char * list_with_spaces , char ** separated_list , int max_elements ) ;

void remove_trailing_slashes ( char * str ) ;
void string_uppercase ( char * str ) ;
void print_all_keys ( parser_table * t ) ;

#endif

 
