/*
 * Minidxr2 - Linux DVD player. Mostly (C) Jack Whitham, 2001
 *
 */

#include <string.h>
#include <assert.h>

#include "player.h"
#include "queue.h"

buffer_type * queue_make_queue ( int size )
{
	buffer_type		* buf ;

	buf = calloc ( 1 , sizeof ( buffer_type ) ) ;
	assert ( buf != NULL ) ;

	buf -> size = size ;
	buf -> number_in_buffer = 0 ;
	buf -> next_read_pos = 0 ;
	buf -> next_write_pos = 0 ;

	buf -> the_buffer = calloc ( size , sizeof ( buffer_item * ) ) ;

	return buf ;
}

int queue_add_to_queue ( buffer_type * buf , void * item )
{
	if ( buf -> number_in_buffer < buf -> size )
	{
		buf -> the_buffer [ buf -> next_write_pos ] = item ;
		buf -> next_write_pos = ( buf -> next_write_pos + 1 ) % buf -> size ;
		buf -> number_in_buffer ++ ;
		return 1 ;
	} else {
		return 0 ;
	}
}

void * queue_remove_from_queue ( buffer_type * buf )
{
	void * item ;

	if ( buf -> number_in_buffer > 0 )
	{
		item = buf -> the_buffer [ buf -> next_read_pos ] ;
		buf -> the_buffer [ buf -> next_read_pos ] = NULL ;
		buf -> next_read_pos = ( buf -> next_read_pos + 1 ) % buf -> size ;
		buf -> number_in_buffer -- ;
		return item ;
	} else {
		return NULL ;
	}
}

int queue_is_space_in_queue ( buffer_type * buf )
{
	return ( buf -> number_in_buffer < buf -> size ) ;
}

int queue_quite_full ( buffer_type * buf )
{
	return (( buf -> number_in_buffer * 100 ) > ( buf -> size * QUITE_FULL_PERCENT )) ;
}


